DROP SEQUENCE periodi_id_seq;

DROP TABLE periodi;

CREATE TABLE periodi (
	id_pratica varchar(9),
	id_attivita char(8),
	id	serial,
	numero integer,
	anno	char(4) DEFAULT '' NOT NULL,
        dal date,
        al date,
	datachiusura date,
        ludalle1 char(4),
        lualle1  char(4),
        ludalle2 char(4),
        lualle2  char(4),
        madalle1 char(4),
        maalle1  char(4),
        madalle2 char(4),
        maalle2  char(4),
        medalle1 char(4),
        mealle1  char(4),
        medalle2 char(4),
        mealle2  char(4),
        gidalle1 char(4),
        gialle1  char(4),
        gidalle2 char(4),
        gialle2  char(4),
        vedalle1 char(4),
        vealle1  char(4),
        vedalle2 char(4),
        vealle2  char(4),
        sadalle1 char(4),
        saalle1  char(4),
        sadalle2 char(4),
        saalle2  char(4),
        dodalle1 char(4),
        doalle1  char(4),
        dodalle2 char(4),
        doalle2  char(4),
	data_inserimento date,
	utente_inserimento char(16),
	deleted   char (1) DEFAULT NULL
);


DROP SEQUENCE toapproveperiodi_id_seq;

DROP TABLE toapproveperiodi;

CREATE TABLE toapproveperiodi (
	id_pratica varchar(9),
	id_attivita char(8),
	id 	serial,
	numero integer,
	anno	char(4) DEFAULT '' NOT NULL,
        dal date,
        al date,
	datachiusura date,
        ludalle1 char(4),
        lualle1  char(4),
        ludalle2 char(4),
        lualle2  char(4),
        madalle1 char(4),
        maalle1  char(4),
        madalle2 char(4),
        maalle2  char(4),
        medalle1 char(4),
        mealle1  char(4),
        medalle2 char(4),
        mealle2  char(4),
        gidalle1 char(4),
        gialle1  char(4),
        gidalle2 char(4),
        gialle2  char(4),
        vedalle1 char(4),
        vealle1  char(4),
        vedalle2 char(4),
        vealle2  char(4),
        sadalle1 char(4),
        saalle1  char(4),
        sadalle2 char(4),
        saalle2  char(4),
        dodalle1 char(4),
        doalle1  char(4),
        dodalle2 char(4),
        doalle2  char(4),
	data_inserimento date,
	utente_inserimento char(16),
	deleted   char(1) DEFAULT NULL,
	approvato  char(1),
	data_approvazione date,
	utente_approvazione char(16)
);


DROP TABLE commercio;

CREATE TABLE commercio (
	id_pratica varchar(9),
	insegna character varying(250),
	idvia integer,
	civico  char(8),
	sub char(3),
	tipoalbergo char(1) DEFAULT NULL,
	camere char(8),
	letti char(8),
	tipomensa char(1) DEFAULT NULL,
        classifica char(8),
        tipoc char(1) DEFAULT NULL,
	attivitaprevalente character varying (250) DEFAULT NULL,
	matricola char(8),
	codicefiscale char (16) DEFAULT NULL,
	telefono character varying (20) DEFAULT NULL,
	fax  character varying (20) DEFAULT NULL,
	email  character varying (100) DEFAULT NULL,
	sito  character varying (100) DEFAULT NULL,
	cod_interno character varying (15) DEFAULT NULL
);

drop table commercioattivita;

create table commercioattivita(
	id_pratica varchar(9),
	idattivita char(8),
	matricola varchar(9)

);

drop table attivita;

create table attivita(
	id char(8),
	descrizione character varying (250) 
);

drop table chiusura;

create table chiusura (
	id_pratica varchar(9),
	anno  char(4),
	giornochiusura integer,
	mezzagiornata  char(1) DEFAULT NULL
	data_inserimento date,
	utente_inserimento char(16)
);


drop table chiusuratemporanea;

create table chiusuratemporanea(
	id_pratica varchar(9),
	dal datetime,
	al datetime,
	motivo varchar(250),
	approved char(1) DEFAULT NULL,
	deleted char(1) DEFAULT NULL,
        id_attivita  char(8)
);


drop table toapprovechiusuratemporanea;


create table toapprovechiusuratemporanea(
        id_pratica varchar(9),
        dal datetime,
        al datetime,
        motivo varchar(250),
        approved char(1) DEFAULT NULL,
        deleted char(1) DEFAULT NULL,
        id_attivita  char(8)
);


drop table toapprovechiusura;

create table toapprovechiusura (      
	id_pratica varchar(9),
	anno  char(4),
	giornochiusura integer,
	mezzagiornata  char(1) DEFAULT NULL,
        utente_inserimento char(16),
	data_inserimento date,
        approvato  char(1),
	data_approvazione date,
	utente_approvazione char(16)
);

drop table vie;

create table vie (
	id char(8),
	nomevia character varying(250),
	zona char(8),
	frazione character varying(250)
);


DROP TABLE com_commercio;

CREATE TABLE com_commercio(
        id      character varying(7)  DEFAULT '' NOT NULL,
	anno char(4) DEFAULT '' NOT NULL,
        id_protocollo  character varying(7)  DEFAULT '' NOT NULL, 
        cod_interno character varying(15) DEFAULT '' NOT NULL,
        dal date,
        al date,
        datachiusura date,
        lun char(16),
        mar char(16),
        mer char(16),
        gio char(16),
        ven char(16),
        sab char(16),
        dom char(16),
        data_inserimento date,
	utente_inserimento char(16)
);

COPY attivita FROM '/home/coloriomauro/www/a_attivita_pe.txt' USING DELIMITERS '|';

COPY vie FROM '/home/coloriomauro/www/vie.txt' USING DELIMITERS '|'; 

COPY commercio FROM '/home/coloriomauro/www/pubblici_esercizi.txt' USING DELIMITERS '|'; 


COPY commercioattivita FROM '/home/coloriomauro/www/attivita_pe.txt' USING DELIMITERS '|';
