
from mx.DateTime import *
import psycopg

# Classe principale dell'applicazione

class pax:    
    "Folder dell'applicazione Pax lato Zope"

    def __init__(self, id):
        "initialise a new instance of zopePax Application"

        self.id = id
   
        DSN='host=localhost\
        dbname=pratiche\
        user=coloriomauro'

        self.DSN = DSN
        self._v_connection = None
        
        if self.connectDB() == None:
            raise "cannot connect the DB", DSN
            exit
            

    def getNumeroRegistrazione(self,cursor, user):

        sqlString = "INSERT INTO protocolli (Numeroregistrazione, utenteinserimento, dataregistrazione, anno)\
        SELECT ltrim(to_char( coalesce(max(to_number(Numeroregistrazione, '9999999')), 0) + 1 , '0000000' )), \
        %s, %s , %s from protocolli where anno=%s"

        params = (user, now().strftime("%d/%m/%Y"), now().strftime("%Y"), now().strftime("%Y"))

        cursor.execute(sqlString,params)
        
        self.secureExecuteDB(cursor, user,  sqlString, params, 1) # Create a new id


        sqlString = "SELECT MAX(numeroregistrazione) from protocolli where anno=%s and utenteinserimento = %s"

        params = (now().strftime("%Y"),user)

        self.secureExecuteDB(cursor,user,  sqlString, params) # Get new id

        results = cursor.fetchone()

        return results[0] #return the new of protocollo



    def connectDB(self, DSN=None):
        "restituisce una connessione valida al database"

      
        if DSN:
            self.DSN=DSN
   
        #try:
        connection = psycopg.connect(self.DSN)
        #except StandardError, err:
        #    raise "Errore di connessione: ", err
        #    return None
        
        self._v_connection = connection
        
        return self.getConnectionDB()

    def getConnectionDB(self):
        if not self.checkConnectionDB():
            return None
        
        return self._v_connection

    def getCursorDB(self):
        if not self.checkConnectionDB():
            return None

        if not self._v_connection:
            raise "qualcosa e' andato storto"
        return  self._v_connection.cursor()

    def checkConnectionDB(self):
        # if not connected connect!
        return 1

    def secureExecuteDB(self,cursor, username, sqlString, params, log=None):
        if not self.checkConnectionDB():
            return None

        if log:
            try:
                cursor.execute("INSERT INTO log VALUES (%s, %s, %s)", (username, now().strftime("%d/%m/%Y %H:%M"), sqlString % params)) 
            except StandardError, err:
                raise "Errore nell'inserimento nella tabella di log" ,err      
    
        try:
            result = cursor.execute(sqlString , params)
        except StandardError, err:
            raise "Errore nell'esecuzione di " + sqlString % params, err      
        

#       self._v_connection.commit()
        
        return result

    
    
